#
# spec file for package mozilla-xulrunner181 (Version 1.8.1.18)
#
# Copyright (c) 2008 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    Mesa Mesa-devel PolicyKit aaa_base acl alsa alsa-devel atk atk-devel attr audiofile audiofile-devel audit-libs autoconf automake bash bind-libs bind-utils binutils bison brp-check-internal bzip2 cairo cairo-devel coreutils cpio cpp cpp41 cracklib cups-libs cvs cyrus-sasl db dbus-1 dbus-1-devel dbus-1-glib dbus-1-glib-devel desktop-translations diffutils e2fsprogs esound esound-devel expat file filesystem fillup findutils flex fontconfig fontconfig-devel freetype2 freetype2-devel gawk gcc gcc-c++ gcc41 gcc41-c++ gconf2 gconf2-devel gdbm gdbm-devel gettext gettext-devel glib2 glib2-devel glibc glibc-devel glibc-locale glitz glitz-devel gnome-filesystem gnome-keyring gnome-keyring-devel gnome-vfs2 gnome-vfs2-devel gpm grep groff gtk2 gtk2-devel gzip hal hal-devel info insserv java-1_5_0-sun java-1_5_0-sun-devel jpackage-utils klogd krb5 less libacl libart_lgpl libart_lgpl-devel libattr libbonobo libbonobo-devel libbonoboui libbonoboui-devel libcom_err libdrm libgcc41 libglade2 libgnome libgnome-devel libgnomecanvas libgnomecanvas-devel libgnomeui libgnomeui-devel libidl libidl-devel libjpeg libjpeg-devel libltdl libmudflap41 libnscd libpng libpng-devel libstdc++41 libstdc++41-devel libtiff libtool libusb libvolume_id libxcrypt libxml2 libxml2-devel libzio linux-kernel-headers m4 mDNSResponder-lib make man mktemp module-init-tools mozilla-nspr mozilla-nspr-devel mozilla-nss mozilla-nss-devel ncurses ncurses-devel net-tools netcfg openldap2-client openssl openssl-devel orbit2 orbit2-devel pam pam-modules pango pango-devel patch perl permissions pkgconfig pm-utils pmtools popt popt-devel post-build-checks procinfo procps psmisc pwdutils rcs readline resmgr rpm sed strace sysvinit tar tcpd texinfo timezone unzip update-alternatives update-desktop-files util-linux vim xorg-x11-devel xorg-x11-fonts-devel xorg-x11-libICE xorg-x11-libICE-devel xorg-x11-libSM xorg-x11-libSM-devel xorg-x11-libX11 xorg-x11-libX11-devel xorg-x11-libXau xorg-x11-libXau-devel xorg-x11-libXdmcp xorg-x11-libXdmcp-devel xorg-x11-libXext xorg-x11-libXext-devel xorg-x11-libXfixes xorg-x11-libXfixes-devel xorg-x11-libXmu xorg-x11-libXmu-devel xorg-x11-libXp xorg-x11-libXp-devel xorg-x11-libXpm xorg-x11-libXpm-devel xorg-x11-libXprintUtil xorg-x11-libXprintUtil-devel xorg-x11-libXrender xorg-x11-libXrender-devel xorg-x11-libXt xorg-x11-libXt-devel xorg-x11-libXv xorg-x11-libXv-devel xorg-x11-libfontenc xorg-x11-libfontenc-devel xorg-x11-libs xorg-x11-libxkbfile xorg-x11-libxkbfile-devel xorg-x11-proto-devel xorg-x11-util-devel xorg-x11-xtrans-devel zip zlib zlib-devel


Name:           mozilla-xulrunner181
BuildRequires:  gcc-c++ java-1_5_0-sun-devel libgnomeui-devel libidl-devel mozilla-nss-devel unzip update-alternatives update-desktop-files zip
License:        GPL v2 or later; LGPL v2.1 or later; MOZILLA PUBLIC LICENSE (MPL/NPL)
Version:        1.8.1.18
Release:        0.1
Summary:        Mozilla Runtime Environment 1.8.1.x
Url:            http://www.mozilla.org/
Group:          Productivity/Other
Provides:       gecko181
%if %suse_version > 1010
Obsoletes:      mozilla-xulrunner
Provides:       mozilla-xulrunner
# For upgrade from 10.2 betas:
Obsoletes:      mozilla-xulrunner180
Provides:       mozilla-xulrunner180
%endif
%if %suse_version == 1020
Provides:       mozilla-xulrunner181 = 1.8.0.99
%endif
%if %suse_version == 1030
Provides:       mozilla-xulrunner181 = 1.8.1.4
%endif
Source:         xulrunner-source-%{version}.tar.bz2
Source1:        l10n-%{version}.tar.bz2
Patch1:         abuild.patch
Patch2:         nss-opt.patch
Patch3:         mozilla-gcc4.3-fixes.patch
Patch4:         idldir.patch
Patch5:         visibility.patch
Patch6:         gcc-undefined-ops.patch
Patch7:         xulrunner-apilibdir.patch
Patch8:         nsIPermission.patch
Patch9:         rpath.patch
Patch10:        system-proxies.patch
Patch12:        mozilla-path_len.patch
Patch13:        abuild2.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
PreReq:         libstdc++ expat pango xorg-x11-libs fontconfig freetype2
PreReq:         gtk2 atk glib2 update-alternatives
### build configuration ###
%define has_system_cairo 0
%define has_system_nspr  0
%define has_system_nss   0
%define pango 0
%if %suse_version > 930 || %is_plus
%define has_system_cairo 1
%define has_system_nspr  1
%endif
%if %is_plus || %suse_version >= 930
%define pango 1
%endif
%if %suse_version > 1010 || %is_plus
# NSS version on 10.1 is too old
%define has_system_nss   1
%endif
%define releasedate 2008110600
%define intversion 1.8.1.18
%define apiversion 1.8.1
%define uaweight 181180
%if %suse_version == 1020
%define ga_version 1.8.1b2
%endif
%if %suse_version == 1030
%define ga_version 1.8.1.4
%endif
### configuration end ###
%define my_provides /tmp/my-provides
%define my_requires /tmp/my-requires
%if %has_system_nspr
PreReq:         mozilla-nspr >= %( echo `rpm -q --queryformat '%{VERSION}' mozilla-nspr`)
%endif
%if %has_system_nss
PreReq:         mozilla-nss >= %( echo `rpm -q --queryformat '%{VERSION}' mozilla-nss`)
%endif

%description
XULRunner is a single installable package that can be used to bootstrap
multiple XUL+XPCOM applications that are as rich as Firefox and
Thunderbird.



Authors:
--------
    Mozilla Foundation <drivers@mozilla.org>

%debug_package
%package devel
License:        GPL v2 or later; LGPL v2.1 or later; MOZILLA PUBLIC LICENSE (MPL/NPL)
Summary:        XULRunner/Gecko SDK 1.8.1.x
Group:          Development/Libraries/Other
%if %suse_version > 1010
Obsoletes:      gecko-sdk
Provides:       gecko-sdk
# For upgrade from 10.2 betas:
Obsoletes:      mozilla-xulrunner180-devel
Provides:       mozilla-xulrunner180-devel
%endif
%if %has_system_nspr
Requires:       mozilla-nspr-devel >= %( echo `rpm -q --queryformat '%{VERSION}' mozilla-nspr-devel`) 
%endif
%if %has_system_nss
PreReq:         mozilla-nss-devel >= %( echo `rpm -q --queryformat '%{VERSION}' mozilla-nss-devel`)
%endif
PreReq:         %{name} = %{version}

%description devel
Software Development Kit to embed XUL or Gecko into other applications.



Authors:
--------
    Mozilla Foundation <drivers@mozilla.org>

%package l10n
License:        GPL v2 or later; LGPL v2.1 or later; MOZILLA PUBLIC LICENSE (MPL/NPL)
Summary:        Translations for XULRunner 1.8.1.x
Group:          Productivity/Other
PreReq:         %{name} = %{version}
%if %suse_version > 1010
# For upgrade from 10.2 betas:
Obsoletes:      mozilla-xulrunner180-l10n
Provides:       mozilla-xulrunner180-l10n
%endif

%description l10n
XULRunner is a single installable package that can be used to bootstrap
multiple XUL+XPCOM applications that are as rich as Firefox and
Thunderbird.

This package contains all supported languages but en-US which is
delivered in the main package.



Authors:
--------
    Mozilla Foundation <drivers@mozilla.org>

%prep
%setup -n mozilla -b 1 -q
%patch1
%patch2
%patch3
%patch4
%patch5 -p1
%patch6
%patch7
%patch8
%patch9
%patch10
%patch12 -p1
%patch13 -p1

%build
export MOZ_BUILD_DATE=%{releasedate}
export LD_LIBRARY_PATH=$RPM_BUILD_DIR/mozilla/dist/bin
export CFLAGS="$RPM_OPT_FLAGS -Os -fno-strict-aliasing"
%if %suse_version > 1000
export CFLAGS="$CFLAGS -fstack-protector"
%endif
%ifarch ppc64
export CFLAGS="$CFLAGS -mminimal-toc"
%endif
export CXXFLAGS="$CFLAGS"
export RPATH="-Wl,-rpath -Wl,%{_libdir}/xulrunner-%{intversion}"
export MOZCONFIG=$RPM_BUILD_DIR/mozconfig
export MOZILLA_OFFICIAL=1
export BUILD_OFFICIAL=1
#
cat << EOF > $MOZCONFIG
mk_add_options MOZILLA_OFFICIAL=1
mk_add_options BUILD_OFFICIAL=1
#mk_add_options MOZ_MILESTONE_RELEASE=1
mk_add_options MOZ_MAKE_FLAGS=%{?jobs:-j%jobs}
. \$topsrcdir/xulrunner/config/mozconfig
ac_add_options --prefix=%{_prefix}
ac_add_options --libdir=%{_libdir}
ac_add_options --sysconfdir=%{_sysconfdir}
ac_add_options --mandir=%{_mandir}
ac_add_options --includedir=%{_includedir}
ac_add_options --enable-optimize="$CFLAGS"
ac_add_options --enable-extensions=default,cookie,permissions
ac_add_options --with-system-jpeg
ac_add_options --with-system-png
ac_add_options --with-system-mng
ac_add_options --with-system-zlib
ac_add_options --enable-default-toolkit=gtk2
ac_add_options --enable-xft
ac_add_options --disable-freetype2
ac_add_options --enable-svg
ac_add_options --enable-canvas
ac_add_options --disable-tests
ac_add_options --disable-installer
EOF
%if %pango
cat << EOF >> $MOZCONFIG
ac_add_options --enable-pango
EOF
%endif
%if %has_system_nspr
cat << EOF >> $MOZCONFIG
ac_add_options --with-system-nspr
EOF
%endif
%if %has_system_nss
cat << EOF >> $MOZCONFIG
ac_add_options --with-system-nss
EOF
%endif
%if %has_system_cairo
cat << EOF >> $MOZCONFIG
ac_add_options --enable-system-cairo
EOF
%endif
make -f client.mk build

%install
make -C xulrunner/installer STRIP=/bin/true
mkdir -p $RPM_BUILD_ROOT%{_libdir}/xulrunner-%{intversion}
mkdir -p $RPM_BUILD_ROOT%{_libdir}/xulrunner-%{intversion}/extensions
mkdir -p $RPM_BUILD_ROOT/usr/bin
cp -rf dist/xulrunner/* $RPM_BUILD_ROOT%{_libdir}/xulrunner-%{intversion}/
# GRE
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/gre.d/
# SDK
mkdir -p $RPM_BUILD_ROOT%{_includedir}/xulrunner-%{intversion}
mkdir -p $RPM_BUILD_ROOT%{_libdir}/pkgconfig
mkdir -p $RPM_BUILD_ROOT%{_libdir}/xulrunner-%{intversion}/bin/
cp -rL dist/sdk/bin/*     $RPM_BUILD_ROOT%{_libdir}/xulrunner-%{intversion}/
cp -rL dist/sdk/lib/*.a   $RPM_BUILD_ROOT%{_libdir}/xulrunner-%{intversion}/
cp -rL dist/sdk/idl/*     $RPM_BUILD_ROOT%{_includedir}/xulrunner-%{intversion}/
cp -rL dist/include/*     $RPM_BUILD_ROOT%{_includedir}/xulrunner-%{intversion}/
cp -rL dist/sdk/include/* $RPM_BUILD_ROOT%{_includedir}/xulrunner-%{intversion}/
cp -rL dist/bin/xulrunner-config  $RPM_BUILD_ROOT%{_bindir}/
install -m 755 $RPM_BUILD_DIR/mozilla/build/unix/xulrunner-*.pc $RPM_BUILD_ROOT%{_libdir}/pkgconfig/
%if %has_system_nss
rm $RPM_BUILD_ROOT%{_libdir}/pkgconfig/xulrunner-nss.pc
ln -sf nss.pc $RPM_BUILD_ROOT%{_libdir}/pkgconfig/xulrunner-nss.pc
%endif
# XPI example
cp -rL dist/xpi-stage/simple $RPM_BUILD_ROOT/%{_libdir}/xulrunner-%{intversion}/
# ghosts
touch $RPM_BUILD_ROOT/%{_libdir}/xulrunner-%{intversion}/global.reginfo
# install additional locales
rm -f %{_tmppath}/translations.list
for locale in $(cat toolkit/locales/all-locales); do
  make -C toolkit/locales libs-$locale
  cp dist/xpi-stage/locale-$locale/chrome/$locale.jar \
     $RPM_BUILD_ROOT/%{_libdir}/xulrunner-%{intversion}/chrome
  cp dist/xpi-stage/locale-$locale/chrome/$locale.manifest \
     $RPM_BUILD_ROOT/%{_libdir}/xulrunner-%{intversion}/chrome
  echo %{_libdir}/xulrunner-%{intversion}/chrome/$locale.jar \
    >> %{_tmppath}/translations.list
  echo %{_libdir}/xulrunner-%{intversion}/chrome/$locale.manifest \
    >> %{_tmppath}/translations.list
done
# API symlink
ln -sf xulrunner-%{intversion} $RPM_BUILD_ROOT%{_libdir}/xulrunner-%{apiversion}
%if 0%{?ga_version:1}
touch $RPM_BUILD_ROOT%{_libdir}/xulrunner-%{ga_version}
%endif
# modify provides and requires lists
%if %has_system_nspr && !%has_system_nss
cat << EOF > %{my_provides}
grep -vE "libnss3.so|libnssckbi.so|libsmime3.so|libsoftokn3.so|libssl3.so|libfreebl3.so" | %{__find_provides}
EOF
chmod 755 %{my_provides}
%define __find_provides %{my_provides}
cat << EOF > %{my_requires}
grep -vE "libnss3.so|libnssckbi.so|libsmime3.so|libsoftokn3.so|libssl3.so|libfreebl3.so|libpipnss.so" | %{__find_requires}
EOF
chmod 755 %{my_requires}
%define __find_requires %{my_requires}
%endif

%clean
rm -rf $RPM_BUILD_ROOT
%if %has_system_nspr && !%has_system_nss
rm -f %{my_provides}
rm -f %{my_requires}
%endif
rm -rf %{_tmppath}/translations.list

%pre
# if an update we need to unregister the old version now
if [ "$1" = "2" ]; then
%ifarch x86_64 ppc64 s390x
  /usr/lib64/xulrunner-%{apiversion}/xulrunner --unregister-global || :
%else
  /usr/lib/xulrunner-%{apiversion}/xulrunner --unregister-global || :
%endif
fi
exit 0

%post
if [ "$1" = "1" ]; then
/usr/sbin/update-alternatives --install %{_bindir}/xulrunner \
  xulrunner %{_libdir}/xulrunner-%{intversion}/xulrunner %{uaweight} || :
fi
%{_libdir}/xulrunner-%{intversion}/xulrunner --register-global || :
%if 0%{?ga_version:1} 
%posttrans
#if [ "$1" = "1" ]; then
test -d %{_libdir}/xulrunner-%{ga_version} && rm -rf %{_libdir}/xulrunner-%{ga_version}
ln -sf xulrunner-%{version} %{_libdir}/xulrunner-%{ga_version}
#fi
exit 0
%endif

%preun
if [ "$1" = "0" ]; then # deinstallation
  %{_libdir}/xulrunner-%{intversion}/xulrunner --unregister-global
  /usr/sbin/update-alternatives --remove xulrunner %{_libdir}/xulrunner-%{intversion}/xulrunner
fi
exit 0

%files
%defattr(-,root,root)
%dir %{_libdir}/xulrunner-%{intversion}/
%dir %{_libdir}/xulrunner-%{intversion}/chrome/
%dir %{_libdir}/xulrunner-%{intversion}/extensions/
%{_libdir}/xulrunner-%{intversion}/chrome/classic.*
%{_libdir}/xulrunner-%{intversion}/chrome/comm.*
%{_libdir}/xulrunner-%{intversion}/chrome/en-US.*
%{_libdir}/xulrunner-%{intversion}/chrome/pippki.*
%{_libdir}/xulrunner-%{intversion}/chrome/toolkit.*
%{_libdir}/xulrunner-%{intversion}/chrome/chromelist.txt
%{_libdir}/xulrunner-%{intversion}/chrome/icons/
%{_libdir}/xulrunner-%{intversion}/components/
%{_libdir}/xulrunner-%{intversion}/defaults/
%{_libdir}/xulrunner-%{intversion}/greprefs/
%{_libdir}/xulrunner-%{intversion}/icons/
%{_libdir}/xulrunner-%{intversion}/plugins/
%{_libdir}/xulrunner-%{intversion}/res/
%{_libdir}/xulrunner-%{intversion}/*.so
%{_libdir}/xulrunner-%{intversion}/LICENSE
%{_libdir}/xulrunner-%{intversion}/README.txt
%{_libdir}/xulrunner-%{intversion}/dependentlibs.list
%{_libdir}/xulrunner-%{intversion}/mozilla-xremote-client
%if !%has_system_nss
%{_libdir}/xulrunner-%{intversion}/libsoftokn3.chk
%{_libdir}/xulrunner-%{intversion}/libfreebl3.chk
%endif
%{_libdir}/xulrunner-%{intversion}/run-mozilla.sh
%{_libdir}/xulrunner-%{intversion}/updater
%{_libdir}/xulrunner-%{intversion}/xpicleanup
%{_libdir}/xulrunner-%{intversion}/xulrunner
%{_libdir}/xulrunner-%{intversion}/xulrunner-bin
%{_libdir}/xulrunner-%{intversion}/xulrunner-stub
%{_libdir}/xulrunner-%{intversion}/javaxpcom.jar
%ghost %{_libdir}/xulrunner-%{intversion}/global.reginfo
# GRE
%dir %{_sysconfdir}/gre.d/
# example
%{_libdir}/xulrunner-%{intversion}/simple/
# API symlink
%{_libdir}/xulrunner-%{apiversion}
%if 0%{?ga_version:1}
%ghost %{_libdir}/xulrunner-%{ga_version}
%endif

%files devel
%defattr(-,root,root)
%{_libdir}/xulrunner-%{intversion}/*.a
%{_libdir}/xulrunner-%{intversion}/regxpcom
%{_libdir}/xulrunner-%{intversion}/xpidl
%{_libdir}/xulrunner-%{intversion}/xpt_dump
%{_libdir}/xulrunner-%{intversion}/xpt_link
%{_bindir}/xulrunner-config
%attr(644,root,root) %{_libdir}/pkgconfig/*
%{_includedir}/xulrunner-%{intversion}/

%files l10n -f %{_tmppath}/translations.list
%defattr(-,root,root)

%changelog
* Fri Nov 21 2008 - maw@suse.de
- Security update to version 1.8.1.18 (bnc#439841)
- Add abuild2.patch.
* Wed Oct 01 2008 - maw@suse.de
- Security update to version 1.8.1.17 (bnc#429179)
- Drop milestone.patch, since it was upstreamed
- Respin abuild.patch.
* Wed May 28 2008 - maw@suse.de
- Add milestone.patch (bnc#378230, comment 15).
* Thu May 22 2008 - maw@suse.de
- Security update to version 1.8.1.14:
  + MFSA 2008-20/CVE-2008-1380: Crash in JavaScript garbage
  collector.
* Thu Apr 03 2008 - maw@suse.de
- Security update to version 1.8.1.13 (bnc#370353):
  + MFSA 2008-19/CVE-2008-1241:  XUL popup spoofing variant
  (cross-tab popups)
  + MFSA 2008-18/CVE-2008-1195 and CVE-2008-1240: Java socket
  connection to any local port via LiveConnect
  + MFSA 2008-17/CVE-2007-4879: Privacy issue with SSL Client
  Authentication
  + MFSA 2008-16/CVE-2008-1238: HTTP Referrer spoofing with
  malformed URLs
  + MFSA 2008-15/CVE-2008-1236 and CVE-2008-1237: Crashes with
  evidence of memory corruption (rv:1.8.1.13)
  + MFSA 2008-14/CVE-2008-1233, CVE-2008-1234, and CVE-2008-1235:
  JavaScript privilege escalation and arbitrary code execution.
* Fri Mar 14 2008 - maw@suse.de
- Fix silly build error
- Fix up API symlinks, which I forgot to do on the previous update.
* Tue Mar 11 2008 - maw@suse.de
- Merge changes from the build service (thanks, Wolfgang)
- Update to version 1.8.1.12 (bnc#354469)
- Drop stale patches.
* Thu Jan 24 2008 - maw@suse.de
- Readjust symlinks that were breaking consuming programs
  (bnc#352925, SWAMP#16075).
* Mon Dec 17 2007 - maw@suse.de
- Merge changes from the build service (thanks, Wolfgang)
- update to security/maintenance release 1.8.1.10 (#341905, #341591)
  * MFSA 2007-37 jar: URI scheme XSS hazard
  * MFSA 2007-38 Memory corruption vulnerabilities
  * MFSA 2007-39 Referer-spoofing via window.location race condition
- Respin visibility.patch and add mozilla-gcc4.3-fixes.patch
- Add mozilla-canvas-1.8.1.10.patch
- Remove upstreamed bmo-294879.patch.
* Wed Aug 22 2007 - maw@suse.de
- Add bmo-294879.patch, fixing crashes when printing observed in
  epiphany (#239911, bugzilla.mozilla.org #294879, and
  SWAMP #12664)
* Tue Nov 28 2006 - kkaempf@suse.de
- also support proper updates for -devel and -l10n subpackages
  (#223891)
* Tue Nov 28 2006 - kkaempf@suse.de
- added 'Provides mozilla-xulrunner180' to properly update
  from 10.2 beta/rc versions (#223891)
* Wed Nov 22 2006 - sbrabec@suse.cz
- Obsolete old xulrunner (#216100).
* Fri Sep 08 2006 - stark@suse.de
- update to snapshot 1.8.1-20060907
  * upstreamed file-saver.patch
* Tue Aug 29 2006 - stark@suse.de
- fixed system-proxies.patch to build again
* Sun Aug 27 2006 - stark@suse.de
- update to snapshot 1.8.1-20060826
- enabled cookie and permissions extensions
- fixed pre-install script
* Wed Aug 23 2006 - stark@suse.de
- update to snapshot 1.8.1-20060822
* Tue Jul 18 2006 - stark@suse.de
- initial package based on mozilla-xulrunner180
